namespace BP
{
	namespace UserEvent
	{
		int instanceIDResult;
		BP::ScriptActor@ scriptResult;
		
		array<kActor@> argActors;
		array<int> argInts;
		array<float> argFloats;
		array<bool> argBools;
		array<kVec3> argVectors;
		array<kStr> argStrings;
		//------------------------------------------------------------------------------------------------------------------------
		void WorldCharSetup(kActor@ srcActor, kActor@ charActor, kActor@ target, const int charValue, const kVec3& in origin, const kVec3& in originOffset, const float offset)
		{
			argInts = array<int> = { charValue };
			argFloats = array<float> = { offset };
			argVectors = array<kVec3> = { origin, originOffset };
			argActors = array<kActor@> = { @srcActor, @target };
			Call(@charActor, USEREVENT_MSG_SPAWN);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void PlayerStarted(kActor@ actor, kActor@ playerActor)
		{
			argActors = array<kActor@> = { @playerActor };
			Call(@actor, USEREVENT_MSG_PLAYER_STARTED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void PlayerRevived(kActor@ actor, kActor@ playerActor)
		{
			argActors = array<kActor@> = { @playerActor };
			Call(@actor, USEREVENT_MSG_PLAYER_REVIVED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void AIStarted(kActor@ actor, kActor@ aiActor)
		{
			argActors = array<kActor@> = { @aiActor };
			Call(@actor, USEREVENT_MSG_AI_STARTED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void AIKilled(kActor@ actor, kActor@ aiActor, kActor@ killer)
		{
			argActors = array<kActor@> = { @aiActor, @killer };
			Call(@actor, USEREVENT_MSG_AI_KILLED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void MapNetReceive(kActor@ actor, int netData, int netData2)
		{
			argInts = array<int> = { netData, netData2 };
			Call(@actor, USEREVENT_MSG_MAP_NETRECEIVE);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void MPPlayerJoin(kActor@ actor, int playerCount)
		{
			argInts = array<int> = { playerCount };
			Call(@actor, USEREVENT_MSG_MP_PLAYER_JOIN);
		}
		//------------------------------------------------------------------------------------------------------------------------
		// void GetScript(kActor@ actor)
		// {
			// @scriptResult = null;
			// Call(@actor, USEREVENT_MSG_GET_SCRIPT);
		// }
		//------------------------------------------------------------------------------------------------------------------------
		void Call(kActor @actor, int msg)
		{
			if (@actor != null)
			{
				Event.RunAction(actor, null, ACTION_USER, Math::vecZero, msg, 0, 0, 0);
				argActors.resize(0);
				argInts.resize(0);
				argFloats.resize(0);
				argBools.resize(0);
				argVectors.resize(0);
				argStrings.resize(0);
			}
			else
			{
				DebugError("[BP::UserEvent::Call] actor is null");
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
