namespace BP
{
	namespace Weapon
	{
		class ChargeDart : ScriptWeapon
		{   
			//------------------------------------------------------------------------------------------------------------------------
			ChargeDart(kWeapon @actor)
			{
				id = kWpn_ChargeDart;
				super(actor);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnBeginFire(void) override
			{
				ScriptWeapon::OnBeginFire();
			//	self.PlaySound("sounds/shaders/Charge Dart PowerUp.ksnd");
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnTick(void) override
			{
				if(self.AnimTrackComponent().PlayingID() == ANIM_WPN_ENTER)
					{
					self.AnimTrackComponent().ChangeSpeed(0.3f);
					}
				if(self.AnimTrackComponent().PlayingID() == ANIM_WPN_EXIT)
					{
					self.AnimTrackComponent().ChangeSpeed(0.3f);
					}
				if(self.AnimTrackComponent().PlayingID() == ANIM_WPN_ATK1)
					{
					self.AnimTrackComponent().ChangeSpeed(0.2f);
					}
				
				if ((self.Owner().Buttons() & BC_ATTACK) != 0)
				{
					
					self.PlayLoopingSound("sounds/shaders/Charge Dart PowerUp.ksnd");
					self.FireProjectile("particles/rubbercharge.particle", kVec3(0, 0, 0));
				}
				else
				{
					self.StopLoopingSounds();
				}
			}	
			//------------------------------------------------------------------------------------------------------------------------
			void OnEndFire(void) override
			{
				ScriptWeapon::OnEndFire();
				
				self.AnimTrackComponent().Flags() |= ANF_CYCLECOMPLETED;
				
				self.PlaySound("sounds/shaders/Charge Dart Fire.ksnd");
			//	self.FireProjectile("particles/rubberball.particle", kVec3(0, 0, 0));
				
				float scalar = self.AnimTrackComponent().PlayTime() * 2.75f;
				if(scalar > 6.0f)
				{
					scalar = 6.0f;
				}
				
				switch(int(scalar))
				{
				case 0:
					self.FireProjectile("particles/rubberball.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(1);
					break;
				case 1:
					self.FireProjectile("particles/rubberball.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(1);
					break;
				case 2:
					self.FireProjectile("particles/rubberball2.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(2);
					break;
				case 3:
					self.FireProjectile("particles/rubberball2.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(2);
					break;
				case 4:
					self.FireProjectile("particles/rubberball2.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(2);
					break;
				case 5:
					self.FireProjectile("particles/rubberball3.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(3);
					break;
				case 6:
					self.FireProjectile("particles/rubberball3.particle", kVec3(0, -10, 0));
					self.Owner().ConsumeAmmo(3);
					break;
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
