namespace BP
{
	namespace Weapon
	{
		class SunfirePod : ScriptWeapon
		{   
			float m_fScalar;
			//------------------------------------------------------------------------------------------------------------------------
			SunfirePod(kWeapon @actor)
			{
				id = kWpn_SunfirePod;
				super(actor);
				m_fScalar = 1.0f;
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnSerialize(kDict& out dict)
			{
				SERIALIZE(m_fScalar);
			}
			
			//------------------------------------------------------------------------------------------------------------------------
			void OnTick(void) override
			{
				ScriptWeapon::OnTick();
				
				if(self.AnimTrackComponent().PlayingID() == ANIM_WPN_ATK1)
				{
					self.AnimTrackComponent().ChangeSpeed(1.0f);
				}	
	
	        if(self.AnimTrackComponent().PlayingID() == ANIM_WPN_ENTER)
				{
					self.AnimTrackComponent().ChangeSpeed(0.3f);
				}
			if(self.AnimTrackComponent().PlayingID() == ANIM_WPN_EXIT)
				{
					self.AnimTrackComponent().ChangeSpeed(0.3f);
			    }
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnDeserialize(kDict& in dict)
			{
				DESERIALIZE_FLOAT(m_fScalar);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnEndFire(void) override
			{
				ScriptWeapon::OnEndFire();
				m_fScalar = Math::Max(0.5f, Math::Min(1.5f, self.AnimTrackComponent().PlayTime()));
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnFiredParticleFromAnim(kParticle@ pPod) override
			{
				ScriptWeapon::OnFiredParticleFromAnim(@pPod);
				pPod.Velocity() *= m_fScalar;
				m_fScalar = 1.0f;
				self.Owner().ConsumeAmmo(1);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnRaise(void) override
			{
				ScriptWeapon::OnRaise();
	        	self.PlaySound("sounds/shaders/raise_baseball.ksnd");
			}
			//------------------------------------------------------------------------------------------------------------------------

		};
	}
}
